"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.identify = void 0;
var async_storage_1 = __importDefault(require("@react-native-async-storage/async-storage"));
var constants_1 = require("../utils/constants");
var sdkState_1 = require("./sdkState");
var getAndSetTraits_1 = require("./getAndSetTraits");
var flush_1 = require("./flush");
var getContext_1 = require("../utils/getContext");
var identify = function (userId, traits, options, eventProperties) {
    if (traits === void 0) { traits = {}; }
    if (options === void 0) { options = {}; }
    if (eventProperties === void 0) { eventProperties = {}; }
    return __awaiter(void 0, void 0, void 0, function () {
        var storedIdentityId, context, payload, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 5, , 6]);
                    if (!sdkState_1.instance) {
                        throw new Error('SDK not initialized. Please call initializeSDK first.');
                    }
                    return [4 /*yield*/, async_storage_1.default.setItem('identityId', userId)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, async_storage_1.default.setItem('userTraits', JSON.stringify(traits))];
                case 2:
                    _a.sent();
                    sdkState_1.instance.userId = userId;
                    (0, getAndSetTraits_1.storeTraits)(traits);
                    return [4 /*yield*/, async_storage_1.default.getItem('identityId')];
                case 3:
                    storedIdentityId = _a.sent();
                    return [4 /*yield*/, (0, getContext_1.getContext)(options)];
                case 4:
                    context = _a.sent();
                    payload = {
                        type: constants_1.EventType.IDENTIFY,
                        apiKey: sdkState_1.instance.apiKey,
                        contractSource: constants_1.ContractSource.REACT_APP,
                        schemaVersion: sdkState_1.instance === null || sdkState_1.instance === void 0 ? void 0 : sdkState_1.instance.schemaVersion,
                        name: 'User Identify',
                        userProperties: traits,
                        contextProperties: __assign(__assign({}, context), { identityId: storedIdentityId || sdkState_1.instance.userId, fingerPrintId: sdkState_1.instance === null || sdkState_1.instance === void 0 ? void 0 : sdkState_1.instance.fingerprintId, sessionId: sdkState_1.instance === null || sdkState_1.instance === void 0 ? void 0 : sdkState_1.instance.sessionId }),
                        eventProperties: eventProperties,
                        timestamp: Date.now(),
                    };
                    (0, flush_1.addEventToQueue)(payload);
                    return [3 /*break*/, 6];
                case 5:
                    error_1 = _a.sent();
                    console.log('Error sending identify event', error_1);
                    throw error_1;
                case 6: return [2 /*return*/];
            }
        });
    });
};
exports.identify = identify;
