"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateAnonymousId = exports.getOptOutStatus = exports.getIdentityId = exports.initializeSDK = exports.instance = exports.setNavigationRef = void 0;
var async_storage_1 = __importDefault(require("@react-native-async-storage/async-storage"));
var constants_1 = require("../utils/constants");
var flush_1 = require("./flush");
var screen_1 = require("./screen");
// import {startNetworkListener} from './networkListner';
var trackLifeCycleEvents_1 = require("./trackLifeCycleEvents");
var networkListner_1 = require("./networkListner");
var FingerprintNative_1 = require("../native/FingerprintNative");
var navigationRef = null;
var setNavigationRef = function (ref) {
    navigationRef = ref;
};
exports.setNavigationRef = setNavigationRef;
var trackCurrentScreen = function () {
    if (navigationRef && (exports.instance === null || exports.instance === void 0 ? void 0 : exports.instance.trackScreenViews)) {
        var currentRoute = navigationRef.getCurrentRoute();
        if (currentRoute) {
            console.log('currentRoute -> ', currentRoute.name);
            var name_1 = currentRoute.name;
            (0, screen_1.screen)(null, name_1);
        }
    }
};
var startScreenTracking = function () {
    if (navigationRef) {
        navigationRef.addListener('state', trackCurrentScreen);
    }
};
exports.instance = null;
var DEFAULT_FLUSH_INTERVAL = 30 * 1000;
var DEFAULT_FLUSH_QUEUE_SIZE = 20;
var DEFAULT_API_URL = constants_1.API_URL;
var setApiHost = function (host) {
    if (!exports.instance) {
        console.error('SDK instance is not initialized.');
        return;
    }
    try {
        var urlParts = DEFAULT_API_URL.split('/');
        urlParts[2] = host;
        var updatedUrl = urlParts.join('/');
        // console.log('Final Updated Url', updatedUrl);
        exports.instance.apiHost = updatedUrl;
    }
    catch (error) {
        console.error('Error Setting API host: ', error);
    }
};
var initializeSDK = function (apiKey, options) {
    if (options === void 0) { options = {}; }
    return __awaiter(void 0, void 0, void 0, function () {
        var storedIdentityId, fingerprintId, storedEventQueue;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!!exports.instance) return [3 /*break*/, 4];
                    return [4 /*yield*/, (0, exports.getIdentityId)()];
                case 1:
                    storedIdentityId = _b.sent();
                    return [4 /*yield*/, (0, FingerprintNative_1.getFingerprintId)()];
                case 2:
                    fingerprintId = _b.sent();
                    console.log('FINGER PRINT ID----> ', fingerprintId);
                    _a = {
                        anonymousId: (0, exports.generateAnonymousId)(),
                        userId: null,
                        apiKey: apiKey,
                        traits: {},
                        groupId: null,
                        eventQueue: [],
                        trackScreenViews: (options === null || options === void 0 ? void 0 : options.trackScreenViews) || false
                    };
                    return [4 /*yield*/, (0, exports.getOptOutStatus)()];
                case 3:
                    exports.instance = (_a.optOutStatus = _b.sent(),
                        _a.flushInterval = options.flushInterval || DEFAULT_FLUSH_INTERVAL,
                        _a.flushQueueSize = options.flushQueueSize || DEFAULT_FLUSH_QUEUE_SIZE,
                        _a.identityId = storedIdentityId,
                        _a.sessionId = (0, exports.generateAnonymousId)(),
                        _a.fingerprintId = fingerprintId,
                        _a.apiHost = DEFAULT_API_URL,
                        _a.schemaVersion = options.schemaVersion || 'Default',
                        _a);
                    if (options.apiHost) {
                        setApiHost(options.apiHost);
                    }
                    _b.label = 4;
                case 4: return [4 /*yield*/, async_storage_1.default.getItem('eventQueue')];
                case 5:
                    storedEventQueue = _b.sent();
                    if (!storedEventQueue) return [3 /*break*/, 7];
                    exports.instance.eventQueue = JSON.parse(storedEventQueue);
                    return [4 /*yield*/, (0, flush_1.flush)()];
                case 6:
                    _b.sent(); // Try to flush stored events on app launch
                    _b.label = 7;
                case 7:
                    startFlushTimer();
                    if (exports.instance.trackScreenViews) {
                        startScreenTracking();
                    }
                    (0, trackLifeCycleEvents_1.trackLifeCycleEvents)();
                    (0, networkListner_1.startNetworkListener)();
                    return [2 /*return*/];
            }
        });
    });
};
exports.initializeSDK = initializeSDK;
var flushTimer = null;
// new
var startFlushTimer = function () {
    if (flushTimer) {
        clearInterval(flushTimer);
    }
    flushTimer = setInterval(function () {
        (0, flush_1.flush)();
    }, (exports.instance === null || exports.instance === void 0 ? void 0 : exports.instance.flushInterval) || DEFAULT_FLUSH_INTERVAL);
};
var getIdentityId = function () { return __awaiter(void 0, void 0, void 0, function () {
    var identityId, error_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, async_storage_1.default.getItem('identityId')];
            case 1:
                identityId = _a.sent();
                return [2 /*return*/, identityId];
            case 2:
                error_1 = _a.sent();
                console.log("Error while fetching identityId", error_1 === null || error_1 === void 0 ? void 0 : error_1.message);
                return [2 /*return*/, null];
            case 3: return [2 /*return*/];
        }
    });
}); };
exports.getIdentityId = getIdentityId;
var getOptOutStatus = function () { return __awaiter(void 0, void 0, void 0, function () {
    var storedStatus, error_2;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, async_storage_1.default.getItem('optOutStatus')];
            case 1:
                storedStatus = _a.sent();
                return [2 /*return*/, storedStatus ? JSON.parse(storedStatus) : false];
            case 2:
                error_2 = _a.sent();
                console.error('Error fetching opt-out status', error_2);
                return [2 /*return*/, false];
            case 3: return [2 /*return*/];
        }
    });
}); };
exports.getOptOutStatus = getOptOutStatus;
var generateAnonymousId = function () {
    var timestamp = Date.now().toString(36);
    var randomString = Math.random().toString(36).slice(2, 6);
    var randomLetters = String.fromCharCode(65 + Math.floor(Math.random() * 26)) +
        String.fromCharCode(97 + Math.floor(Math.random() * 26));
    return "".concat(randomLetters, "-").concat(timestamp, "-").concat(randomString);
};
exports.generateAnonymousId = generateAnonymousId;
