import {getDefaultContext} from '../utils/contextUtils';
import {instance} from './sdkState';

export const getAnalyticsContext = async () => {
  try {
    if (!instance) {
      throw new Error('SDK not initialized. Please call initializeSDK first.');
    }

    const context = await getDefaultContext();
    return context;
  } catch (error) {
    console.error('Error getting analytics context:', error);
    throw error;
  }
};
