import NetInfo from '@react-native-community/netinfo';
import {flush} from './flush';

export const checkNetworkStatus = async () => {
  const state = await NetInfo.fetch();
  return state.isConnected; // Return true if online, false if offline
};

export const startNetworkListener = () => {
  NetInfo.addEventListener(state => {
    const isOnline = state.isConnected;
    console.log(isOnline ? 'Device is online' : 'Device is offline');
    if (isOnline) {
      flush(); // used to sync events dynamically when the device comes 
    }
  });
};
