import AsyncStorage from '@react-native-async-storage/async-storage';
import {instance} from './sdkState';

export const optOut = async (shouldOptOut: boolean) => {
  if (!instance) {
    throw new Error('SDK not initialized. Please call initializeSDK first.');
  }

  instance.optOutStatus = shouldOptOut;

  try {
    await AsyncStorage.setItem('optOutStatus', JSON.stringify(shouldOptOut));
    console.log(`Opt-out status set to: ${shouldOptOut}`);
  } catch (error) {
    console.error('Error saving opt-out status', error);
  }
};
