import AsyncStorage from '@react-native-async-storage/async-storage';
import {instance} from './sdkState';

export const reset = async () => {
  if (!instance) {
    throw new Error('SDK not initialized. Nothing to reset.');
  }
  instance.userId = null;
  instance.traits = {};
  // instance.anonymousId = generateAnonymousId();
  instance.groupId = null;
  instance.optOutStatus = false;

  try {
    await AsyncStorage.removeItem('identityId');
    await AsyncStorage.removeItem('optOutStatus');
    await AsyncStorage.removeItem('userTraits');
    await AsyncStorage.removeItem('eventQueue');
    await AsyncStorage.removeItem('customContext')

    console.log('Data cleared from AsyncStorage.');
  } catch (error) {
    console.error('Error clearing AsyncStorage:', error);
  }

  console.log('SDK state has been reset.');
};
