export const API_URL =
  'https://social-media-callbacks-tier0.dev3.gocommotion.com/sdkevent/callback/bulk';

export enum EventType {
  IDENTIFY = 'IDENTIFY',
  TRACK = 'TRACK',
  GROUP = 'GROUP',
  SCREEN = 'SCREEN',
}

export enum ContractSource {
  // IOS_APP = 'IOS_APP',
  // ANDROID_APP = 'ANDROID_APP',
  // WEBSITE = 'WEBSITE',
  REACT_APP = 'REACT_APP',
}
export interface AppContext {
  name: string;
  version: string;
  build: string;
}

export interface DeviceContext {
  deviceType: string;
  deviceId: string;
  manufacturer: string;
  model: string;
  name: string;
}

export interface LibraryContext {
  name: string;
  version: string;
}

export interface OSContext {
  name: string;
  version: string;
}

export interface NetworkContext {
  carrier: string | null;
}

export interface DefaultContext {
  app: AppContext;
  device: DeviceContext;
  library: LibraryContext;
  os: OSContext;
  network: NetworkContext;
}

export interface Traits {
  firstName?: string;
  lastName?: string;
  email?: string;
  phone?: any;
  gender?: string;
  age?: number;
  custom?: Record<string, unknown>;
  [key: string]: any;
}

export interface Options {
  context?: Record<string, any>; // accept any key-value pairs
}

// export interface IdentifyPayload {
//   type: EventType.IDENTIFY;
//   userId: string;
//   anonymousId?: string | null;
//   traits?: Traits;
//   // options?: Options;
//   context?: DefaultContext | any; // Overridden context
//   timestamp: number;
//   // apiKey: string;
// }

export interface TrackPayload {
  type: EventType.TRACK;
  eventName: string;
  properties?: Record<string, unknown>;
  context?: DefaultContext | any;
  timestamp: number;
  apiKey: string | any;
  traits: any;
  contractSource: string;
  schemaVersion: string;
}

export interface GroupPayload {
  type: EventType.GROUP;
  groupId: string;
  traits: Traits;
  context: Record<string, any>;
  timestamp: number;
  userId: string | null;
  apiKey: string | null;
}
